/* 
 * Copyright (c) 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 973 $ $LastChangedDate: 2002-09-14 18:46:12 +0200 (Sat, 14 Sep 2002) $
 *
 * Runtime environment for Gont, Core module implementation.
 */

open Core;

/* Input. */
int read_int()
{
    return atoi(read_string());
}

float read_float()
{
    return atof(read_string());
}

/* Pair opertations. */
'a fst(*('a, 'b) p)
{
    let (a, _) = p in
    return a;
}

'b snd(*('a, 'b) p)
{
    let (_, b) = p in
    return b;
}

// Warning about ,,unused global symbol Core::__dummy_disaster'' and 
// ,,dead code'' here is normal
void __dummy_disaster()
{
    // make sure these are linked (other are referenced elsewhere in
    // this module)
    raise Null_access;
    raise Match_failure;
    raise Not_found;
    raise End_of_file;
    raise Sys_error("");
    raise Invalid_argument("");
    raise Failure("");
    raise Invalid_multibyte_sequence;
    raise Incomplete_multibyte_sequence;
    raise Invalid_unicode_character;
    raise Character_not_supported_by_encoding;
}

/* Character type. */
typedef int char;

char char_of_int(int x)
{
    if (x < 0 || x > 0x7fffffff)
        raise Invalid_argument("char_of_int");
    return x;
}

int int_of_char(char x)
{
    return x;
}

/* String <-> bool conversion.  */
string string_of_bool(bool b)
{
    switch b {
    case true:
	return "true";
    case false:
	return "false";
    }
}

bool bool_of_string(string s)
{
    switch s {
    case "true":
	return true;
    case "false":
	return false;
    case _:
	raise Invalid_argument("Core::bool_of_string");
    }
}


/* Ref.  */
'a ref_get(<'a>ref r)
{
    return r.ref_contents;
}

void ref_set(<'a>ref r, 'a a)
{
    r.ref_contents = a;
}

<'a>ref ref_make('a a)
{
    return {ref_contents = a};
}

/* Utilities.  */

void ignore('a)
{
}

*('a ('b)) partial(*('a ('c, 'b)) f, 'c c)
{
	return (fun 'a ('b b) (f(c, b)));
}

*('a ('b)) partial2(*('a ('c, 'd, 'b)) f, 'c c, 'd d)
{
	return (fun 'a ('b b) (f(c, d, b)));
}


// vim:sts=4:sw=4
