/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 977 $ $LastChangedDate: 2002-09-14 19:10:23 +0200 (Sat, 14 Sep 2002) $
 *
 * Fileutil - Various file utility functions.
 */

/** Return [filename] with directory part removed.  */
string basename(string filename);

/** Return just directory part of [filename].  */
string dirname(string filename);

/** Return (part of [filename] up to last dot, part of [filename] after 
    last dot), or [(filename, "")] if there is no dot.  */
*(string, string) split_filename(string filename);

/** Lookup [filename] in each directory in [path].  Return filename with 
    path where it was found, or raise [Not_found].  */
string find_in_path(<string>list path, string filename);

/** Print [msg] on [stderr], prepending [Array::get(Sys::argv, 0)].  */
void report_error(string msg);
