// Test polimorphic unions
// $Rev: 930 $ $LastChangedDate: 2002-09-11 09:36:02 +0200 (Wed, 11 Sep 2002) $

def print_int(x) (puts(itoa(x)))
union <'a>xlist {
	void Xnil;
	*('a, <'a>xlist) Xcons;
}

int length(<'a>xlist l)
{
	switch l {
	case Xnil():
		return 0;
	case Xcons(_, tl):
		return 1 + length(tl);
	}
}

void iter(*(void ('a)) f, <'a>xlist l)
{
	switch l {
	case Xnil():
		return;
		
	case Xcons(hd, tl):
		f(hd);
		iter(f, tl);
	}
}

<'b>xlist map(*('b ('a)) f, <'a>xlist l)
{
	switch l {
	case Xnil():
		return Xnil();		

	case Xcons(hd, tl):
		return Xcons(f(hd), map(f, tl));
	}
}

string i2s(int i)
{
	switch i {
	case 10:
		return "ten";
	case 20:
		return "twenty";
	case _:
		return "hgw";
	}
}

section init
{
	<int>xlist i;
	<string>xlist s;
	
	i = Xcons(1, Xcons(10, Xcons(20, Xnil)));
	s = Xcons("foo", Xcons("bar", Xcons("baz", Xnil())));

	iter(print_int, i);
	puts(".");
	iter(puts, s);
	puts(".");
	iter(puts, map(i2s, i));
	puts(".");
	
	print_int(length(i));
	puts(".");
	print_int(length(s));
	puts(".\n");
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 11020.foobarbaz.hgwtentwenty.3.3.
 */
